#include <stdio.h>
#include <math.h>
#include <string.h>
#include <sys/types.h> 
  
#define BUFF_LEN 256
  
  
main(int argc , char *argv[])
 {
	  
    FILE *filer; 
    FILE *filew; 
    char namefile[BUFF_LEN],linea[BUFF_LEN],res[BUFF_LEN];
    float phi,psi,dc;
    int min,max,bmax,deg,bin[360][360],color[10];        
    int phi0,phi1,psi0,psi1,nphi,npsi,in_phi,in_psi;
    int cont,i,j,k;
    

    min=0;max=100;
    deg=4;
    phi0 = -180  ; phi1 = 180 ;
    psi0 = -180  ; psi1 = 180 ; 

    for(i=1 ; i < argc; i++) {
	if (strcmp(argv[i],"-phi0") == 0)  phi0=atoi(argv[++i]);
	if (strcmp(argv[i],"-phi1") == 0)  phi1=atoi(argv[++i]);
	if (strcmp(argv[i],"-psi0") == 0)  psi0=atoi(argv[++i]);
	if (strcmp(argv[i],"-psi1") == 0)  psi1=atoi(argv[++i]);
	if (strcmp(argv[i],"-deg" ) == 0)  deg =atoi(argv[++i]);	
	if (strcmp(argv[i],"-max" ) == 0)  max =atoi(argv[++i]);	
	if (strcmp(argv[i],"-min" ) == 0)  min =atoi(argv[++i]);		
    }	

    if(max>100 || min>100 || max<0 || min <0) {
	printf("Error:  -min or -max outside of bounds");
	exit(1);
    }

    printf("Using phi0: %i\n",phi0);
    printf("Using phi1: %i\n",phi1);
    printf("Using psi0: %i\n",psi0);
    printf("Using psi1: %i\n",psi1);
    printf("Using deg : %i\n",deg );
    printf("Using min : %i\n",min );
    printf("Using max : %i\n",max );    


    cont=0;
    nphi = (phi1 - phi0) / deg;
    npsi = (psi1 - psi0) / deg;

    strcpy(namefile,"rama.xvg");
    filer = fopen(namefile,"r");
    if(filer == NULL) {
	printf("ERROR - can't open input file '%s' \n",namefile);
        exit(1);
     }
			       
    strcpy(namefile,"rama.xpm");
    filew = fopen(namefile,"w");
    if(filer == NULL) {
	printf("ERROR - can't open input file '%s' \n",namefile);
        exit(1);
     }


    for (j = 1; j <= npsi; j++) {
        for (i = 1; i <= nphi; i++) {
            bin[i][j] = 0;
        }
    }


    while (fgets(linea , BUFF_LEN , filer) != NULL) {
	if ((strncmp(linea,"@",1) != 0) && (strncmp(linea,"#",1) != 0)){
    	    sscanf(linea,"%f %f %s", &phi, &psi, res);
    	    if ((phi >= phi0) && (phi < phi1) && (psi >= psi0) && (psi < psi1))  {
		for ( i = 1; i <= nphi; i++) {
		    if ((phi > (phi0 + (i - 1) * deg)) && (phi <= (phi0 + i * deg))) {in_phi = i ; break;}
		}
		for ( j = 1; j <= npsi; j++) {
		    if ((psi > (psi0 + (j - 1) * deg)) && (psi <= (psi0 + j * deg))) {in_psi = j ; break;}
		}
		bin[in_phi][in_psi]++ ;
	    }
	cont++;	    
	}    
    }


    bmax=0;
    for (j = npsi; j >= 1; j--) {
	for (i = 1; i <= nphi; i++) {
	    if (bin[i][j] > bmax) bmax=bin[i][j];  
	}
    }

/*normalize*/
    for (j = npsi; j >= 1; j--) {
	for (i = 1; i <= nphi; i++) {
	     bin[i][j]= 100.0 - 100.0 * (((float)bmax-(float)bin[i][j])/(float)bmax);  
	}
    }

    dc=(max-min)/10.0;
    for (k=0; k<=9; k++) {
    	color[k]= k*dc+min;    
    }


    fprintf(filew,"/* XPM */\n");
    fprintf(filew,"/* title:   \"Ramachandran Plot\" */\n");
    fprintf(filew,"/* legend:  \"\" */\n");
    fprintf(filew,"/* x-label: \"Phi\" */\n");
    fprintf(filew,"/* y-label: \"Psi\" */\n");
    fprintf(filew,"/* type:    \"Discrete\" */\n");
    fprintf(filew,"static char *gromacs_xpm[] = {\n");
    fprintf(filew,"\"%i %i  12 1\",\n",nphi,npsi);
    fprintf(filew,"\"w  c #FFFFFF\" /* \"<%i\" */,\n",min);                
    fprintf(filew,"\"0  c #FF0000\" /* \"%i-%-i\" */,\n",color[0],color[1]);
    fprintf(filew,"\"1  c #FF7000\" /* \"%i-%-i\" */,\n",color[1],color[2]);
    fprintf(filew,"\"2  c #FF9900\" /* \"%i-%-i\" */,\n",color[2],color[3]);
    fprintf(filew,"\"3  c #FFFF00\" /* \"%i-%-i\" */,\n",color[3],color[4]);
    fprintf(filew,"\"4  c #99FF00\" /* \"%i-%-i\" */,\n",color[4],color[5]);
    fprintf(filew,"\"5  c #00FF00\" /* \"%i-%-i\" */,\n",color[5],color[6]);
    fprintf(filew,"\"6  c #00FF99\" /* \"%i-%-i\" */,\n",color[6],color[7]);
    fprintf(filew,"\"7  c #00FFFF\" /* \"%i-%-i\" */,\n",color[7],color[8]);
    fprintf(filew,"\"8  c #0080FF\" /* \"%i-%-i\" */,\n",color[8],color[9]);
    fprintf(filew,"\"9  c #0000FF\" /* \"%i-%-i\" */,\n",color[9],max);
    fprintf(filew,"\"b  c #000000\" /* \">%i\" */,\n",max);
    fprintf(filew,"/* x-axis: "); for (i= 1; i<= nphi ; i++) fprintf(filew,"%i ",phi0+(i-1)*deg);fprintf(filew,"*/\n");
    fprintf(filew,"/* y-axis: "); for (i= 1; i<= npsi ; i++) fprintf(filew,"%i ",psi0+(i-1)*deg);fprintf(filew,"*/\n");
    

    for (j = npsi; j >= 1; j--) {
        fprintf(filew,"\"");
        for (i = 1; i <= nphi; i++) {
    	    for (k=0; k<=9; k ++) {
    	        if (bin[i][j] < min) {fprintf(filew,"w"); break;}
    	        if (bin[i][j] >= max) {fprintf(filew,"b"); break;}		
		if ((bin[i][j] >= (k*dc)+min) && (bin[i][j] < ((k+1)*dc)+min)) {fprintf(filew,"%i",k); break;}
	    }
        }
        fprintf(filew,"\",\n");
    }
    
    fclose(filer);
    fclose(filew);
    printf("Done ...\n");

}
